#include "stringcompleter.h"

StringCompleter::StringCompleter(QObject *parent) :
    QObject(parent),
    m_data(),
    m_results(),
    m_lastSearchNeedle()
{
}

void StringCompleter::setData(const QStringList &list)
{
    m_data = list;
}

const QStringList & StringCompleter::data()
{
    return m_data;
}

void StringCompleter::search(const QString &needle)
{
    QStringList* data = &m_data;

    if(needle.startsWith(m_lastSearchNeedle, Qt::CaseInsensitive))
    {
        // Search deeper in the results from the previous run. We reuse the previous results as data.
        data = &m_results;
    }
    else
    {
        m_results.clear();
    }

    foreach (const QString &str, *data)
    {
        if(str.startsWith(needle, Qt::CaseInsensitive))
        {
            m_results << str;
            emit searchHit(str);
        }
    }

    m_lastSearchNeedle = needle;
    emit searchCompleted(m_results, needle);
}
